from Components.ActionMap import *
from Components.Button import Button
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.Pixmap import Pixmap
from enigma import ePicLoad
from Tools.LoadPixmap import LoadPixmap
from Components.AVSwitch import AVSwitch
from Components.Sources.StaticText import StaticText
from Plugins.Plugin import PluginDescriptor
from Screens.InfoBarGenerics import *
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from Screens.InfoBar import MoviePlayer, InfoBar
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ProgressBar import ProgressBar
from string import find
from Tools.Directories import fileExists, pathExists
from Components.config import *
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config, ConfigSubsection, ConfigText, getConfigListEntry, ConfigSelection, ConfigPIN
from Components.ProgressBar import ProgressBar
from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_WRAP
from enigma import getDesktop, eServiceReference, iServiceInformation, iPlayableService
from enigma import loadJPG, loadPNG
from twisted.web import client
from twisted.web.client import downloadPage, getPage
from Screens.MessageBox import MessageBox
from Components.PluginComponent import plugins
import re, urllib, urllib2, os, cookielib, time
from urllib import urlencode
from VirtualKeyBoard import VirtualKeyBoard
import sha
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/JobManager/plugin.pyo'):
    from Plugins.Extensions.JobManager.plugin import *
    JobManagerInstalled = True
else:
    JobManagerInstalled = False
UserAgent = 'Mozilla/5.0 (X11; U; Linux x86_64; de; rv:1.9.0.15) Gecko/2009102815 Ubuntu/9.04 (jaunty) Firefox/3.'

class m2list(MenuList):

    def __init__(self, list):
        MenuList.__init__(self, list, False, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 14))
        self.l.setFont(1, gFont('Regular', 16))
        self.l.setFont(2, gFont('Regular', 18))
        self.l.setFont(3, gFont('Regular', 20))
        self.l.setFont(4, gFont('Regular', 22))
        self.l.setFont(5, gFont('Regular', 24))
        self.l.setFont(6, gFont('Regular', 26))
        self.l.setFont(7, gFont('Regular', 28))


def show_letter_movie(name, link, image):
    res = [(name, link, image)]
    res.append(MultiContentEntryText(pos=(0, 0), size=(590, 24), font=4, text=name, flags=RT_HALIGN_LEFT))
    return res


def show_letter(letter, link):
    res = [(letter, link)]
    res.append(MultiContentEntryText(pos=(0, 0), size=(200, 16), font=1, text=letter, flags=RT_HALIGN_LEFT))
    return res


class Veetle(Screen):
    skin = '\n\t<screen position="35,55" size="1210,640" title=" ">\n\t<widget name="logo" position="450,1" size="200,50" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/veetle_logo.png" zPosition="1" alphatest="on" />\n\t<widget name="logo2" position="0,0" size="1200,630" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/logo2.png" zPosition="0" alphatest="on" />\n\t\t<widget source="session.VideoPicture" render="Pig"  position="750,120" size="340,228" zPosition="3" backgroundColor="transparent"/>\t\n\t<widget name="progressBar" position="10,35" pixmap="skin_default/progress_small.png" zPosition="1" borderWidth="2" size="170,7" />\n\t<widget name="text" position="10,2" size="550,40" zPosition="0" font="Regular;24" halign="left" valign="center" transparent="1" foregroundColor="#000000" backgroundColor="#000000" />\n\t<widget name="poster" position="10,120" size="150,225" zPosition="4" alphatest="on" />\n\t<widget name="menulist2" position="15,350" size="185,240" scrollbarMode="showNever" transparent="1" />\n\t<widget name="menulist" position="205,120" size="500,450" transparent="1" scrollbarMode="showOnDemand" />\n\t<widget name="ButtonRed" position="28,596" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/red.png" zPosition="10" size="150,30" transparent="1" alphatest="on" />\n\t<widget name="TextRed" position="28,600" size="140,24" valign="center" halign="center" zPosition="11" font="Regular;18" transparent="1" />\n\t<widget name="ButtonGreen" position="196,596" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/green.png" zPosition="10" size="150,30" transparent="1" alphatest="on" />\n\t<widget name="TextGreen" position="196,600" size="140,24" valign="center" halign="center" zPosition="11" font="Regular;18" transparent="1" />\t\t\t\n\t<widget name="ButtonBlue" position="532,596" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/blue.png" zPosition="10" size="150,30" transparent="1" alphatest="on" />\n\t<widget name="TextBlue" position="532,600" size="140,24" valign="center" halign="center" zPosition="11" font="Regular;18" transparent="1" />\n\t<widget name="ButtonYellow" position="364,596" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/yellow.png" zPosition="10" size="150,30" transparent="1" alphatest="on" />\n\t<widget name="TextYellow" position="364,600" size="140,24" valign="center" halign="center" zPosition="11" font="Regular;18" transparent="1" />\n\t<widget name="plugin_logo" position="750,330" size="390,260" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/ArabicEntertainment/images/logo_veetle.png" zPosition="1" alphatest="on" />\n\t</screen>'

    def __init__(self, session):
        
        self.skin_path = Veetle.skin
        self.session = session
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['OkCancelActions',
         'ColorActions',
         'DirectionActions',
         'MovieSelectionActions'], {'up': self.up,
         'down': self.down,
         'left': self.left,
         'right': self.right,
         'ok': self.ok,
         'cancel': self.exit,
         'green': self.search,
         'blue': self.dnitnow}, -1)
        self['InfobarActions'] = HelpableActionMap(self, 'InfobarActions', {'showMovies': self.jobix}, -1)
        self['EPGSelectActions'] = HelpableActionMap(self, 'EPGSelectActions', {'nextBouquet': self.switchList,
         'prevBouquet': self.switchList}, -1)
        self['menulist'] = m2list([])
        self['menulist2'] = m2list([])
        self['menulist2'].hide()
        self['ButtonBlue'] = Pixmap()
        self['ButtonBlue'].hide()
        self['TextBlue'] = Label('Download')
        self['ButtonGreen'] = Pixmap()
        self['TextGreen'] = Label('Search')
        self['ButtonRed'] = Pixmap()
        self['TextRed'] = Label('Search')
        self['ButtonYellow'] = Pixmap()
        self['TextYellow'] = Label('About')
        self['TextBlue'].hide()
        self['plugin_logo'] = Pixmap()
        self['logo2'] = Pixmap()
        self['logo'] = Pixmap()
        self['text'] = Label('')
        self['text'].setText('Loading data..')
        self['progressBar'] = ProgressBar()
        self['progressBar'].setValue(0)
        self['poster'] = Pixmap()
        self.dnfile = 'False'
        self.currentList = 'menulist'
        self.menulist = []
        self.menulist2 = []
        self.loading_ok = False
        self.check = 'abc'
        self.count = -1
        self.loading = 0
        self.dir()
        self.onLayoutFinish.append(self.abc)

    def jobix(self):
        if JobManagerInstalled:
            self.session.open(JobManagerFrontEnd)

    def dnitnow(self):
        if JobManagerInstalled and self.check == 'letter_movie':
            self.dnfile = 'True'
            link = self['menulist'].getCurrent()[0][1]
            self.filmname = self['menulist'].getCurrent()[0][0]
            self.get_play_link(self.filmname, link)

    def up(self):
        self[self.currentList].up()
        if self.currentList == 'menulist':
            self.show_cover()

    def down(self):
        self[self.currentList].down()
        if self.currentList == 'menulist':
            self.show_cover()

    def left(self):
        self[self.currentList].pageUp()
        if self.currentList == 'menulist':
            self.show_cover()

    def right(self):
        self[self.currentList].pageDown()
        if self.currentList == 'menulist':
            self.show_cover()

    def switchList(self):
        if self.currentList == 'menulist':
            self['ButtonBlue'].hide()
            self['TextBlue'].hide()
            self['menulist'].selectionEnabled(0)
            self['menulist2'].selectionEnabled(1)
            self.currentList = 'menulist2'
            self.check = 'abc'
        else:
            self['ButtonBlue'].show()
            self['TextBlue'].show()
            self['menulist'].selectionEnabled(1)
            self['menulist2'].selectionEnabled(0)
            self.currentList = 'menulist'
            self.check = 'letter_movie'

    def abc(self):
        self.loading_ok = False
        self.check = 'abc'
        self.currentList = 'menulist2'
        self.letter_list = []
        self.letter_movielist = []
        self['menulist'].selectionEnabled(0)
        self['menulist2'].selectionEnabled(1)
        self['menulist2'].show()
        self['text'].setText('Select category.')
        self.genre_name = 'Veetle Streams'
        cat = [('Animation', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/60/0/39/0'),
         ('Comedy', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/50/0/39/0'),
         ('Education', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/90/0/39/0'),
         ('Gaming', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/40/0/39/0'),
         ('Mobile', 'http://veetle.com/index.php/stream/ajaxStreamBySearch/0/39/0/2.0/'),
         ('Entertainment', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/10/0/39/0'),
         ('Shows', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/20/0/39/0'),
         ('Sports', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/80/0/39/0'),
         ('Music', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/70/0/39/0'),
         ('News', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/30/0/39/0'),
         ('Religion', 'http://veetle.com/index.php/listing/ajaxStreamByCategory/100/0/39/0')]
        for each in cat:
            category, link = each
            self.letter_list.append(show_letter(category, link))

        self['menulist2'].l.setList(self.letter_list)
        self['menulist2'].l.setItemHeight(40)
        self['menulist2'].moveToIndex(5)
        genre_link = self['menulist2'].getCurrent()[0][1]
        self.count = 0
        self.start('http://veetle.com/index.php/listing/ajaxStreamByCategory/10/0/39/0', 0)

    def search(self):
        self.session.openWithCallback(self.searchVeetle, VirtualKeyBoard, title=_('Enter name of the Channel'))

    def searchVeetle(self, searchstring = None):
        self.search_list = []
        if searchstring:
            searchstring_fin = searchstring.replace(' ', '+')
            print searchstring_fin
            url = 'http://veetle.com/index.php/stream/ajaxStreamBySearch/0/39/0/2.0/' + searchstring_fin
            getPage(url, timeout=15, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.search_data)

    def search_data(self, data):
        movies = re.findall('{"userId":".*?username":".*?","channelId":"(.*?)",".*?","thumbnailUrl":"(.*?)","thumbnailUrlSmall":".*?title":"(.*?)","description":".*?"', data, re.DOTALL)
        for each in movies:
            url, thumb, title = each
            url = 'http://veetle.com/index.php/stream/ajaxStreamLocation/' + url + '/flash'
            thumb = str(thumb).replace('\\', '')
            title = str(title).replace('\\u25ba', '').replace('\\u25c4', '').replace('\\u25c4', '').replace('\\u1d0f', '').replace('\\u026a', '').replace('\\u0274', '').replace('\\u1d1cs', '').replace('\\u1d0f', '').replace('\\u0280', '').replace('\\u1d07', '').replace('\\u1d21', '').replace('\\u2134', '').replace('\\u0475', '').replace('\\u212f', '').replace('\\u25ac', '')
            title = str(title).replace('\\u029f', '').replace('\\u1d00', '').replace('\\u028f', '').replace('\\u026as', '').replace('\\u1d1bs', '').replace('\\u1d05', '').replace('\\u2666', '').replace('\\u00a8', '').replace('\\u25b2', '').replace('\\u2665', '').replace('\\u2022', '').replace('\\u2112', '').replace('\\u266a', '').replace('\\u2588', '').replace('\\u2580', '')
            title = str(title).replace('\\u00bb', '').replace('\\u00ab', '').replace('\\u000c', '').replace('\\u00a0', '').replace('\\u2460', '').replace('\\u2122', '').replace('\\u00b4', '').replace('\\u2606', '')
            self.search_list.append(show_letter_movie(title, url, thumb))

        self['menulist'].l.setList(self.search_list)
        self['menulist'].l.setItemHeight(40)

    def start(self, main_url, count):
        getPage(main_url, timeout=8, method='GET', headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.load_data, main_url).addErrback(self.errorload2)

    def load_data(self, data, main_url):
        movies = re.findall('{"userId":".*?","username":".*?","channelId":"(.*?)","sessionId":".*?","thumbnailUrl":"(.*?)","thumbnailUrlSmall":".*?","title":"(.*?)","description":".*?","location"', data, re.DOTALL)
        for each in movies:
            url, thumb, title = each
            url = 'http://veetle.com/index.php/stream/ajaxStreamLocation/' + url + '/flash'
            thumb = str(thumb).replace('\\', '')
            title = str(title).replace('\\u25ba', '').replace('\\u25c4', '').replace('\\u25c4', '').replace('\\u1d0f', '').replace('\\u026a', '').replace('\\u0274', '').replace('\\u1d1cs', '').replace('\\u1d0f', '').replace('\\u0280', '').replace('\\u1d07', '').replace('\\u1d21', '').replace('\\u2134', '').replace('\\u0475', '').replace('\\u212f', '').replace('\\u25ac', '')
            title = str(title).replace('\\u029f', '').replace('\\u1d00', '').replace('\\u028f', '').replace('\\u026as', '').replace('\\u1d1bs', '').replace('\\u1d05', '').replace('\\u2666', '').replace('\\u00a8', '').replace('\\u25b2', '').replace('\\u2665', '').replace('\\u2022', '').replace('\\u2112', '').replace('\\u266a', '').replace('\\u2588', '').replace('\\u2580', '')
            title = str(title).replace('\\u00bb', '').replace('\\u00ab', '').replace('\\u000c', '').replace('\\u00a0', '').replace('\\u2460', '').replace('\\u2122', '').replace('\\u00b4', '').replace('\\u2606', '')
            title = str(title).replace('(((\\u246)))', '').replace('\\u25cf', ' ').replace('\\u06e9', '').replace('\\u06de', '').replace('\\u2605', '').replace('\\u008c', '').replace('\\u2461', '').replace('\\u2462', '')
            self.letter_movielist.append(show_letter_movie(title, url, thumb))
        self['menulist'].l.setList(self.letter_movielist)
        self['menulist'].l.setItemHeight(40)
        self.show_cover()

    def get_play_link(self, name, url):
        uri = 'http://veetle.com/index.php/channel/view'
        print uri
        req = urllib2.Request(uri)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.8.1.14) Gecko/20080404 Firefox/2.0.0.14')
        page = urllib2.urlopen(req)
        response = page.read()
        page.close()
        cookie = page.info()['Set-Cookie']
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.8.1.14) Gecko/20080404 Firefox/2.0.0.14')
        req.add_header('Referer', 'http://veetle.com/index.php/search/video/')
        req.add_header('Cookie', cookie)
        page = urllib2.urlopen(req)
        response = page.read()
        self.read_link(response)

    def read_link(self, data):
        link = re.findall('{"success":true,"payload":"(.*?)","', data)
        print data
        playp = str(link[0]).replace('\\', '')
        print playp
        if link:
            self.play_movie(playp)

    def play_movie(self, link):
        if link:
            sref = eServiceReference(4097, 0, link)
            sref.setName(self.filmname)
            self.session.open(MoviePlayer, sref)

    def ok(self):
        if self.check == 'abc':
            self.index_nr = self['menulist2'].getSelectedIndex()
            self.genre_name = self['menulist2'].getCurrent()[0][0]
            genre_link = self['menulist2'].getCurrent()[0][1]
            #self.letter_movielist = []
            self.start(genre_link, -1)
        elif self.check == 'letter_movie':
            self.filmname = self['menulist'].getCurrent()[0][0]
            link = self['menulist'].getCurrent()[0][1]
            self.dnfile = 'False'
            self.get_play_link(self.filmname, link)

    def exit(self):
        os.system('rm -rf /tmp/Veetle')
        self.close()

    def show_cover(self):
        jpg_link = self['menulist'].getCurrent()[0][2]
        jpg_name = self['menulist'].getCurrent()[0][0]
        jpg_store = '/tmp/Veetle/%s' % jpg_name
        if not os.path.exists(jpg_store):
            downloadPage(jpg_link, jpg_store).addCallback(self.downloadPic, jpg_store).addErrback(self.errorload)
        else:
            self.poster_resize(jpg_store)

    def downloadPic(self, data, jpg_store):
        if fileExists(jpg_store):
            self.poster_resize(jpg_store)
        else:
            print '[Veetle] thumb not found.'

    def poster_resize(self, poster_path):
        self['poster'].instance.setPixmap(None)
        self['poster'].hide()
        sc = AVSwitch().getFramebufferScale()
        self.picload = ePicLoad()
        size = self['poster'].instance.size()
        self.picload.setPara((size.width(),
         size.height(),
         sc[0],
         sc[1],
         False,
         1,
         '#FF000000'))
        if self.picload.startDecode(poster_path, 0, 0, False) == 0:
            ptr = self.picload.getData()
            if ptr != None:
                self['poster'].instance.setPixmap(ptr)
                self['poster'].show()
            else:
                print '[Veetle] no thumb.. error'
        return

    def stream_not_found(self):
        message = self.session.open(MessageBox, _('Stream not found'), MessageBox.TYPE_INFO, timeout=3)

    def errorload2(self, error):
        count_movies = len(self.letter_movielist)
        self['text'].setText('Found %s movies in -%s-' % (count_movies, self.genre_name))
        self['progressBar'].setValue(int(100))
        self.loading_ok = True
        self.loading = 0
        self.count = -1

    def errorload(self, error):
        print ''

    def dir(self):
        if not pathExists('/tmp/Veetle/'):
            os.system('mkdir /tmp/Veetle/')
        else:
            print '[Veetle] /tmp/Veetle/ vorhanden.'


def main(session, **kwargs):
    session.open(Veetle, plugin_path)


def Plugins(path, **kwargs):
    global plugin_path
    plugin_path = path
    return [PluginDescriptor(name='Veetle', description='Veetle Streamer', where=[PluginDescriptor.WHERE_PLUGINMENU], fnc=main, icon='plugin.png')]

